import {Conf, ConfDprobeHeartbeat} from "../../types/conf";
import {urlWatcher, UrlWatcherResult} from '../abstract/url-watcher'
import * as moment from 'moment'

export function dprobeHeartbeat(conf: Conf) {

  return async (dconf: ConfDprobeHeartbeat) => {

    return urlWatcher(conf, async (data) => {
      const last = moment(data, 'YYYY-MM-DD HH:mm:ss\n')
      const past = moment().diff(last)
      if (past > dconf.lastBeat) {
        return UrlWatcherResult.ko('Delay is over')
      }
      return UrlWatcherResult.ok()
    })(dconf,
        () => `State OK hearbeat is up-to-date`,
        () => `State FAILURE hearbeat`,
        () => `State RECOVERED hearbeat`)
  }
}
